Class Application
'    Private Sub rf_convert_for_table__tbl_assets()
'#  Script: Repeating Fields Conversion for table: tbl_Assets
'# 
'#  Requirements: This script must be run from a layout for the table containing the repeating fields.
'#  Parameters: None
'#  Global Fields: None
'#  Post Processing: None
'#  This script calls scripts to convert repeating fields data for each repeating field in the table, prior to transferring repeating fields data with FmPro Migrator.
'#  This process works around an issue with FileMaker 7+ ODBC drivers not supporting repeating fields.
'# 
'#  Compatibility: Requires FileMaker 8 Advanced, FileMaker Pro/Advanced 9 or higher
'#  9/13/2007 - Initial Release - .com Solutions Inc.
'#  4/24/2018 - Added support for new FileMaker 14+ script comment XML code - .com Solutions Inc.
'# 
'Go to Layout [ "assets_v8" ]
'Perform Script [ RF Convert for Field: Serial Number 2;  ]
'    End Sub 

'    Private Sub main_prg()
'# /* FileMaker Pro */
'# 
'# /* Define error messages */
'# Let ( [
'#     ERR_LOC = "Error: ";
'#     FILEINUSE_LOC = "A form cannot simultaneously be open in design mode and running.";
'#     FILEREADONLY_LOC = "One of the necessary files is marked as read-only." & Char(13) & "Please make sure you have read and write access to the file.";
'#     
'#     /* Get error code */
'#     errorCode = Get(LastError)
'# ];
'#     
'#     /* Handle errors */
'#     Case (
'#         errorCode = 3 ; /* File is in use */
'#             Show Custom Dialog [ Message: ERR_LOC & Get(LastMessage) & Char(13) & FILEINUSE_LOC; Buttons: "OK" ];
'#             
'#         errorCode = 1718 ; /* File is read-only */
'#             Show Custom Dialog [ Message: ERR_LOC & Get(LastMessage) & Char(13) & FILEREADONLY_LOC; Buttons: "Retry" ];
'#             Perform Script [ "SolutionErrHandle" ];
'#             
'#         errorCode = 1881 ; /* Trying to load DE of solution.scx when table is already open */
'#             Close All [ With dialog: Off ];
'#             Perform Script [ "solution" ];
'#             
'#         /* Other errors */
'#         True ;
'#             lnChoice = Show Custom Dialog [ Message: ERR_LOC & AllTrim(ToString(errorCode)) & Char(13) & Get(LastMessage); Buttons: "Cancel", "OK" ];
'#             If ( lnChoice = 1 ) ; /* Cancel */
'#                 Halt Script;
'#             End If
'#     )
'# )
'    End Sub 

'    Private Sub main_prg_2()
'# /* FileMaker Pro */
'# 
'# /* Define error messages */
'# Let ( [
'#     ERR_LOC = "Error: ";
'#     FILEINUSE_LOC = "A form cannot simultaneously be open in design mode and running.";
'#     FILEREADONLY_LOC = "One of the necessary files is marked as read-only." & Char(13) & "Please make sure you have read and write access to the file.";
'#     
'#     /* Get error code */
'#     errorCode = Get(LastError)
'# ];
'#     
'#     /* Handle errors */
'#     Case (
'#         errorCode = 3 ; /* File is in use */
'#             Show Custom Dialog [ Message: ERR_LOC & Get(LastMessage) & Char(13) & FILEINUSE_LOC; Buttons: "OK" ];
'#             
'#         errorCode = 1718 ; /* File is read-only */
'#             Show Custom Dialog [ Message: ERR_LOC & Get(LastMessage) & Char(13) & FILEREADONLY_LOC; Buttons: "Retry" ];
'#             Perform Script [ "SolutionErrHandle" ];
'#             
'#         errorCode = 1881 ; /* Trying to load DE of solution.scx when table is already open */
'#             Close All [ With dialog: Off ];
'#             Perform Script [ "solution" ];
'#             
'#         /* Other errors */
'#         True ;
'#             lnChoice = Show Custom Dialog [ Message: ERR_LOC & AllTrim(ToString(errorCode)) & Char(13) & Get(LastMessage); Buttons: "Cancel", "OK" ];
'#             If ( lnChoice = 1 ) ; /* Cancel */
'#                 Halt Script;
'#             End If
'#     )
'# )
'    End Sub 

'    Private Sub rf_convert_for_field__serial_number_2()
'#  Script: Repeating Fields Conversion for field: Serial Number
'# 
'#  Requirements: This script must be run from a layout for the table containing the repeating fields.
'#  Parameters: None
'#  Global Fields: None
'#  Post Processing: None
'#  This script converts repeating field values to TAB separated values for processing by FmPro Migrator.
'#  Each repeating value is concatenated together into repeating field data value [1].
'#  This process works around an issue with FileMaker 7+ ODBC drivers not supporting repeating fields.
'# 
'#  Compatibility: Requires FileMaker 8 Advanced or higher
'#  9/13/2007 - Initial Release - .com Solutions Inc.
'#  3/26/2008 - Initialized LoopCounter=1.
'# 
'Set Variable [ $MaxRepeatingCount; Value: 3 ] 
'Show All Records 
'Go to Record/Request/Page 
'    [ First ]
'#  Loop thru all records on current layout
'Loop 
'Set Variable [ $LoopCount; Value: 1 ] 
'Set Variable [ $TempRepeatingData; Value: "" ] 
'Loop 
'#  Loop thru all repeat values for specified field
'#  Concatenate data values separated by TAB chars
'Set Variable [ $TempRepeatingData; Value: If ( $LoopCount=1 ; asset_management2::Serial Number[$LoopCount] ; $TempRepeatingData & "	" & asset_management2::Serial Number[$LoopCount] ) ] 
'Set Variable [ $LoopCount; Value: $LoopCount+1 ] 
'Exit Loop If  [ $LoopCount > $MaxRepeatingCount ] 
'End Loop 
'#  Put concatenated data together into Field[1] - 1st Repeat value of repeating field.
'Set Field [ asset_management2::Serial Number; $TempRepeatingData ] 
'#  Clear temp data - before next record
'Set Variable [ $TempRepeatingData; Value: "" ] 
'Go to Record/Request/Page 
'    [ Next; Exit after last ]
'End Loop 
'    End Sub 

'    Private Sub open_script()
'Perform Script [ Update Today Field;  ]
'Show/Hide Toolbars 
'    [ Show ] 
'Perform Script [ Clear Sort Indicator;  ]
'Go to Layout [ "Form" ]
'Adjust Window 
'    [ ResizeToFit ]
'    End Sub 

'    Private Sub clear_sort_indicator()
'Set Field [ asset_management2::HiliteSortedBy; "" ] 
'    End Sub 

'    Private Sub toggle_window()
'Adjust Window 
'    [ ResizeToFit ]
'    End Sub 

'    Private Sub find()
'Set Error Capture [ On ]
'If  [ Get(WindowMode) = 0 ] 
'# We're in Browse Mode: Enter Find Mode
'Enter Find Mode  [ ] 
'    [ Pause ] 
'Else 
'# We're already in Find Mode. Let the Find button function the same as the Continue button.
'End If 
'Perform Find  [ ] 
'If  [ Get( LastError) = 400 ] 
'Show Custom Dialog [ Title: "Message"; Message: "No find criteria were entered. All records will be displayed." ] 
'Show All Records 
'Else 
'If  [ Get(FoundCount)=0 ] 
'Show Custom Dialog [ Title: "Message"; Message: "No records match this request." ] 
'Show All Records 
'Else 
'If  [ Get(FoundCount)=1 ] 
'Go to Layout [ original layout ]
'Else 
'Go to Layout [ "List" ]
'End If 
'End If 
'End If 
'    End Sub 

'    Private Sub go_to_form_layout()
'Go to Layout [ "Form" ]
'Adjust Window 
'    [ ResizeToFit ]
'    End Sub 

'    Private Sub go_to_information_layout()
'Go to Layout [ "Information" ]
'Adjust Window 
'    [ ResizeToFit ]
'    End Sub 

'    Private Sub go_to_list_layout()
'Perform Script [ Clear Sort Indicator;  ]
'Go to Layout [ "List" ]
'    End Sub 

'    Private Sub sort_by_category()
'If  [ asset_management2::HiliteSortedBy = "categoryA" ] 
'Perform Script [ Sort by Category Descending;  ]
'Exit Script  [  ] 
'End If 
'If  [ asset_management2::HiliteSortedBy = "categoryD" ] 
'Perform Script [ Sort by Category Ascending;  ]
'Exit Script  [  ] 
'End If 
'Set Field [ asset_management2::HiliteSortedBy; "categoryA" ] 
'Perform Script [ Sort by Category Ascending;  ]
'    End Sub 

'    Private Sub sort_by_item()
'If  [ asset_management2::HiliteSortedBy = "itemA" ] 
'Perform Script [ Sort by Item Descending ;  ]
'Exit Script  [  ] 
'End If 
'If  [ asset_management2::HiliteSortedBy = "itemD" ] 
'Perform Script [ Sort by Item Ascending ;  ]
'Exit Script  [  ] 
'End If 
'Set Field [ asset_management2::HiliteSortedBy; "itemA" ] 
'Perform Script [ Sort by Item Ascending ;  ]
'    End Sub 

'    Private Sub sort_by_model()
'If  [ asset_management2::HiliteSortedBy = "modelA" ] 
'Perform Script [ Sort by Model Descending ;  ]
'Exit Script  [  ] 
'End If 
'If  [ asset_management2::HiliteSortedBy = "modelD" ] 
'Perform Script [ Sort by Model Ascending ;  ]
'Exit Script  [  ] 
'End If 
'Set Field [ asset_management2::HiliteSortedBy; "modelA" ] 
'Perform Script [ Sort by Model Ascending ;  ]
'    End Sub 

'    Private Sub sort_by_serial_number()
'If  [ asset_management2::HiliteSortedBy = "serialNumberA" ] 
'Perform Script [ Sort by Serial Number Descending;  ]
'Exit Script  [  ] 
'End If 
'If  [ asset_management2::HiliteSortedBy = "serialNumberD" ] 
'Perform Script [ Sort by Serial Number Ascending;  ]
'Exit Script  [  ] 
'End If 
'Set Field [ asset_management2::HiliteSortedBy; "serialNumberA" ] 
'Perform Script [ Sort by Serial Number Ascending;  ]
'    End Sub 

'    Private Sub sort_by_assigned_to()
'If  [ asset_management2::HiliteSortedBy = "assignedToA" ] 
'Perform Script [ Sort by Assigned To Descending;  ]
'Exit Script  [  ] 
'End If 
'If  [ asset_management2::HiliteSortedBy = "assignedToD" ] 
'Perform Script [ Sort by Assigned To Ascending;  ]
'Exit Script  [  ] 
'End If 
'Set Field [ asset_management2::HiliteSortedBy; "assignedToA" ] 
'Perform Script [ Sort by Assigned To Ascending;  ]
'    End Sub 

'    Private Sub sort_by_location()
'If  [ asset_management2::HiliteSortedBy = "locationA" ] 
'Perform Script [ Sort by Location Descending ;  ]
'Exit Script  [  ] 
'End If 
'If  [ asset_management2::HiliteSortedBy = "locationD" ] 
'Perform Script [ Sort by Location Ascending;  ]
'Exit Script  [  ] 
'End If 
'Set Field [ asset_management2::HiliteSortedBy; "locationA" ] 
'Perform Script [ Sort by Location Ascending;  ]
'    End Sub 

'    Private Sub sort_by_category_ascending()
'Set Field [ asset_management2::HiliteSortedBy; "categoryA" ] 
'Sort Records [ Specified Sort Order: asset_management2::Category; ascending; 
'  asset_management2::Item; ascending ] 
'    [ Restore; No dialog ] 
'Go to Record/Request/Page 
'    [ First ]
'    End Sub 

'    Private Sub sort_by_category_descending()
'Set Field [ asset_management2::HiliteSortedBy; "categoryD" ] 
'Sort Records [ Specified Sort Order: asset_management2::Category; descending; 
'  asset_management2::Item; ascending ] 
'    [ Restore; No dialog ] 
'Go to Record/Request/Page 
'    [ First ]
'    End Sub 

'    Private Sub sort_by_item_ascending()
'Set Field [ asset_management2::HiliteSortedBy; "itemA" ] 
'Sort Records [ Specified Sort Order: asset_management2::Item; ascending ] 
'    [ Restore; No dialog ] 
'Go to Record/Request/Page 
'    [ First ]
'    End Sub 

'    Private Sub sort_by_item_descending()
'Set Field [ asset_management2::HiliteSortedBy; "itemD" ] 
'Sort Records [ Specified Sort Order: asset_management2::Item; descending ] 
'    [ Restore; No dialog ] 
'Go to Record/Request/Page 
'    [ First ]
'    End Sub 

'    Private Sub sort_by_model_ascending()
'Set Field [ asset_management2::HiliteSortedBy; "modelA" ] 
'Sort Records [ Specified Sort Order: asset_management2::Model; ascending ] 
'    [ Restore; No dialog ] 
'Go to Record/Request/Page 
'    [ First ]
'    End Sub 

'    Private Sub sort_by_model_descending()
'Set Field [ asset_management2::HiliteSortedBy; "modelD" ] 
'Sort Records [ Specified Sort Order: asset_management2::Model; descending ] 
'    [ Restore; No dialog ] 
'Go to Record/Request/Page 
'    [ First ]
'    End Sub 

'    Private Sub sort_by_serial_number_ascending()
'Set Field [ asset_management2::HiliteSortedBy; "serialNumberA" ] 
'Sort Records [ Specified Sort Order: asset_management2::Serial Number; ascending ] 
'    [ Restore; No dialog ] 
'Go to Record/Request/Page 
'    [ First ]
'    End Sub 

'    Private Sub sort_by_serial_number_descending()
'Set Field [ asset_management2::HiliteSortedBy; "serialNumberD" ] 
'Sort Records [ Specified Sort Order: asset_management2::Serial Number; descending ] 
'    [ Restore; No dialog ] 
'Go to Record/Request/Page 
'    [ First ]
'    End Sub 

'    Private Sub sort_by_assigned_to_ascending()
'Set Field [ asset_management2::HiliteSortedBy; "assignedToA" ] 
'Sort Records [ Specified Sort Order: asset_management2::Assigned To; ascending ] 
'    [ Restore; No dialog ] 
'Go to Record/Request/Page 
'    [ First ]
'    End Sub 

'    Private Sub sort_by_assigned_to_descending()
'Set Field [ asset_management2::HiliteSortedBy; "assignedToD" ] 
'Sort Records [ Specified Sort Order: asset_management2::Assigned To; descending ] 
'    [ Restore; No dialog ] 
'Go to Record/Request/Page 
'    [ First ]
'    End Sub 

'    Private Sub sort_by_location_ascending()
'Set Field [ asset_management2::HiliteSortedBy; "locationA" ] 
'Sort Records [ Specified Sort Order: asset_management2::Location; ascending ] 
'    [ Restore; No dialog ] 
'Go to Record/Request/Page 
'    [ First ]
'    End Sub 

'    Private Sub sort_by_location_descending()
'Set Field [ asset_management2::HiliteSortedBy; "locationD" ] 
'Sort Records [ Specified Sort Order: asset_management2::Location; descending ] 
'    [ Restore; No dialog ] 
'Go to Record/Request/Page 
'    [ First ]
'    End Sub 

'    Private Sub inventory_report()
'Allow User Abort  [ Off ]
'Print Setup [ Orientation: Portrait; Paper size: 8.5" x 11" ]
'    [ Restore; No dialog ] 
'Go to Layout [ "" ]
'Perform Script [ Sort by Category Ascending;  ]
'Enter Preview Mode 
'    [ Pause ] 
'Go to Layout [ original layout ]
'Enter Browse Mode 
'    End Sub 

'    Private Sub depreciation_report()
'Allow User Abort  [ Off ]
'Print Setup [ Orientation: Portrait; Paper size: 8.5" x 11" ]
'    [ Restore; No dialog ] 
'Go to Layout [ "" ]
'Perform Script [ Sort by Category Ascending;  ]
'Enter Preview Mode 
'    [ Pause ] 
'Go to Layout [ original layout ]
'Enter Browse Mode 
'    End Sub 

'    Private Sub your_own_report()
'Show Custom Dialog [ Title: "Message"; Message: "Create your own script and attach it to this button." ] 
'    End Sub 

'    Private Sub import_images()
'Import Records  [ Folder Name: Temp; Include all enclosed folders; File type: Picture and movie files; Import only a reference; Target: "asset_management2"; Method: Add; Character set: "Mac Roman"; Field Mapping: Source field 1 import to asset_management2::ID  
'Source field 2 import to asset_management2::Assigned To  
'Source field 4 import to asset_management2::Category  
'Source field 5 import to asset_management2::Check Out Days  
'Source field 6 import to asset_management2::Cost  
'Source field 7 import to asset_management2::Created By  
'Source field 8 import to asset_management2::Date Assigned  
'Source field 9 import to asset_management2::Date Check In  
'Source field 10 import to asset_management2::Date Check Out  
'Source field 11 import to asset_management2::Date Created  
'Source field 13 import to asset_management2::Date Modified  
'Source field 14 import to asset_management2::Date Placed  
'Source field 15 import to asset_management2::Date Purchased  
'Source field 17 import to asset_management2::Depreciation Life  
'Source field 21 import to asset_management2::HiliteLibrary  
'Source field 25 import to asset_management2::HiliteSortedBy  
'Source field 26 import to asset_management2::Information  
'Source field 27 import to asset_management2::Item  
'Source field 28 import to asset_management2::Location  
'Source field 29 import to asset_management2::Model  
'Source field 31 import to asset_management2::Picture  
'Source field 32 import to asset_management2::Purchased From  
'Source field 34 import to asset_management2::Serial Number  
'Source field 35 import to asset_management2::Template Information Global  
'Source field 39 import to asset_management2::Assigned Display  
'Source field 40 import to asset_management2::Sample Calc  ] 
'    End Sub 

'    Private Sub update_today_field()
'#  The Today function was removed in FileMaker Pro 7.
'#  The 'Today' field and this script were generated by conversion.
'#  On startup, this script updates the value of the 'Today' field in all records if the date has changed.
'Set Error Capture [ On ]
'New Window [ Style: Document; Using layout: <Current Layout> ] 
'Perform Find  [ Specified Find Requests: Omit Records; Criteria: asset_management2::Today: "//" ] 
'    [ Restore ] 
'Replace Field Contents [ asset_management2::Today; Replace with calculation: Get(CurrentDate) ] 
'    [ No dialog ]
'Close Window [ Current Window ]
'    End Sub 

'    Private Sub rf_convert_for_table__asset_management2()
'#  Script: Repeating Fields Conversion for table: Asset_Management2
'# 
'#  Requirements: This script must be run from a layout for the table containing the repeating fields.
'#  Parameters: None
'#  Global Fields: None
'#  Post Processing: None
'#  This script calls scripts to convert repeating fields data for each repeating field in the table, prior to transferring repeating fields data with FmPro Migrator.
'#  This process works around an issue with FileMaker 7/8/9 ODBC drivers not supporting repeating fields.
'# 
'#  Compatibility: Requires FileMaker 8 Advanced, FileMaker Pro/Advanced 9 or higher
'#  9/13/2007 - Initial Release - .com Solutions Inc.
'# 
'Go to Layout [ "Form" ]
'Perform Script [ RF Convert for Field: Serial Number;  ]
'    End Sub 

'    Private Sub rf_convert_for_field__serial_number()
'#  Script: Repeating Fields Conversion for field: Serial Number
'# 
'#  Requirements: This script must be run from a layout for the table containing the repeating fields.
'#  Parameters: None
'#  Global Fields: None
'#  Post Processing: None
'#  This script converts repeating field values to TAB separated values for processing by FmPro Migrator.
'#  Each repeating value is concatenated together into repeating field data value [1].
'#  This process works around an issue with FileMaker 7/8/9 ODBC drivers not supporting repeating fields.
'# 
'#  Compatibility: Requires FileMaker 8 Advanced, FileMaker Pro/Advanced 9 or higher
'#  9/13/2007 - Initial Release - .com Solutions Inc.
'#  3/26/2008 - Initialized LoopCounter=1.
'# 
'Set Variable [ $MaxRepeatingCount; Value: 3 ] 
'Show All Records 
'Go to Record/Request/Page 
'    [ First ]
'#  Loop thru all records on current layout
'Loop 
'Set Variable [ $LoopCount; Value: 1 ] 
'Set Variable [ $TempRepeatingData; Value: "" ] 
'Loop 
'#  Loop thru all repeat values for specified field
'#  Concatenate data values separated by TAB chars
'Set Variable [ $TempRepeatingData; Value: If ( $LoopCount=1 ; asset_management2::Serial Number[$LoopCount] ; $TempRepeatingData & "	" & asset_management2::Serial Number[$LoopCount] ) ] 
'Set Variable [ $LoopCount; Value: $LoopCount+1 ] 
'Exit Loop If  [ $LoopCount > $MaxRepeatingCount ] 
'End Loop 
'#  Put concatenated data together into Field[1] - 1st Repeat value of repeating field.
'Set Field [ asset_management2::Serial Number; $TempRepeatingData ] 
'#  Clear temp data - before next record
'Set Variable [ $TempRepeatingData; Value: "" ] 
'Go to Record/Request/Page 
'    [ Next; Exit after last ]
'End Loop 
'    End Sub 

'    Private Sub open_url_test()
'Open URL [ "http://www.fmpromigrator.com" ]
'    End Sub 

'    Private Sub export_images()
'# 
'# Export Container Field Images 1/12/2012
'# 
'# 
'Go to Layout [ "" ]
'Set Error Capture [ Off ]
'Show All Records 
'Go to Record/Request/Page 
'    [ First ]
'Loop 
'#  Picture
'If  [ /*Length ( GetAsText ( Items::ItemPicture ) ) >0*/ ] 
'Set Variable [ $OutputFilename1; Value: /*Substitute ( "images/" & Items::Filename1 ; ".jpg" ; "_" )*/ ] 
'Set Variable [ $OutputFilename1; Value: /*$OutputFilename1  & GetAsText ( Items::ItemPicture )*/ ] 
'Export Field Contents [ "$OutputFilename1" ]
'End If 
'#  Picture2
'If  [ /*Length ( GetAsText (Items::ItemPicture2 ) ) >0*/ ] 
'Set Variable [ $OutputFilename2; Value: /*Substitute ( "images/" & Items::Filename2 ; ".jpg" ; "_" )*/ ] 
'Set Variable [ $OutputFilename2; Value: /*$OutputFilename2  & GetAsText ( Items::ItemPicture2 )*/ ] 
'Export Field Contents [ "$OutputFilename2" ]
'End If 
'#  Picture3
'If  [ /*Length ( GetAsText (Items::ItemPicture3 ) ) >0*/ ] 
'Set Variable [ $OutputFilename3; Value: /*Substitute ( "images/" & Items::Filename3 ; ".jpg" ; "_" )*/ ] 
'Set Variable [ $OutputFilename3; Value: /*$OutputFilename3  & GetAsText ( Items::ItemPicture3 )*/ ] 
'Export Field Contents [ "$OutputFilename3" ]
'End If 
'#  Picture4
'If  [ /*Length ( GetAsText (Items::ItemPicture4 ) ) >0*/ ] 
'Set Variable [ $OutputFilename4; Value: /*Substitute ( "images/" & Items::Filename4 ; ".jpg" ; "_" )*/ ] 
'Set Variable [ $OutputFilename4; Value: /*$OutputFilename4  & GetAsText ( Items::ItemPicture4 )*/ ] 
'Export Field Contents [ "$OutputFilename4" ]
'End If 
'Go to Record/Request/Page 
'    [ Next; Exit after last ]
'End Loop 
'    End Sub 

'    Private Sub reverse(Text)
'Case ( ValueCount ( Text ) > 0 ;
'
'Reverse ( RightValues ( Text ; ValueCount ( Text ) - 1 ) ) & LeftValues (
'Text ; 1 ) ; 
'
'LeftValues ( Text ; 1 )
'
')
'    End Sub export_images

'    Private Sub formatnumber_sub(Number,Counter,ThousandSep)
'Case ( Counter > 0 ; Reverse ( Right ( Number; 3) ) & ThousandSep & FormatNumber_sub ( Left (  Number ; Length ( Number ) -3 ) ; Counter - 1; ThousandSep  ) ; Reverse ( Number ) )
'    End Sub export_images

'    Private Sub enclosingobjects(_objectName,Number,ThousandSep,DecSep)
'Let ( Counter = Int ( ( Length ( Int( Number ) ) - 1 ) / 3 ) ; Case ( Int ( Number ) ≥ 1000 ; Reverse ( FormatNumber_sub ( Int ( Number ) ; Counter ; ThousandSep ) ) ; Int ( Number ) ) & If ( Number = Int ( Number ) ; "" ; DecSep & Filter ( Number - Int ( Number ) ; 1234567890 ) ) )
'    End Sub export_images

'    Private Sub array_cellvaluebycoltitle(array,rowName,column,delimiter,useTitle)
'/*
'
'Name:
'array.cellValueByColTitle
'
'History:
'Created by Tim Anderson, Tim Anderson Group
'www.timanderson.co.uk
'Creation Date: 5 January 2009
'
' 
'Purpose:   
'A function to return the cell value from an array by specifying the row name and column title. Row names must be unique or only the first occurrance will be returned.
'
'Parameters:   
'array
'rowName
'column
'delimiter
'useTitle
' 
'Example: 
'array.cellValueByColTitle ( array ; "row2" ; "length" ; "§";1 ) gives 40
'array.cellValueByColTitle ( array ; "row3" ; 1 ; "§";0 ) gives 500
' (no quotes) where array is
'
'§width§length§height§weight
'row1§40§200§23§160
'row2§200§40§98§121
'row3§500§32§12§90
'
' 
'
'Requires Other Custom Functions:
'None
'
'Other Notes:
'A more complex version of array.cellValueByColNum, this gives you the option to specify column Titles (headers) rather than by number. However you can also specify the column number (the row name is zero) as long as you set useTitle to 0.  
'
'Options:
'None
'
'*/ 
'Let([
'     _headers=Case(useTitle=1;GetValue(array;1);"");
'     _colTitlePosition=Position(_headers & delimiter;delimiter & column & delimiter;1;1);
'     _array=Case(useTitle=1;RightValues(array;ValueCount(array)-1);array);
'     _colNum=Case(useTitle=1; PatternCount(Left(_headers;_colTitlePosition);delimiter)+1;column);
'     _rname="¶" & rowName & "§";
'    _string=Right("¶" & _array;Length(_array)-Position("¶" & _array;_rname;1;1)+1);
'    _row=GetValue(_string;1)];
'
'Case(useTitle=1 and _colTitlePosition=0;"ERROR, Column Title not found"; GetValue(Substitute(_row;delimiter;"¶");_colNum))
')
'    End Sub export_images

'    Private Sub amtcompounded_cf(principal,rate,iterations)
'/* AmtCompounded_cf ( principal ; rate ; iterations ) 
'Thanks to Jeremiah Small for original direction.*/
'
'Let ( raw =
'If ( iterations > 0 ;
'AmtCompounded_cf ( principal + ( principal * rate ) ; rate ; iterations - 1 ) ;
'principal ) ; 
'
'Round ( raw ; 2 )
')//endLet
'    End Sub export_images


End Class
